package io.dekorate.option.adapter;

import io.dekorate.option.config.JvmConfigBuilder;
import java.lang.String;
import java.lang.Integer;
import io.dekorate.project.Project;
import io.dekorate.project.BuildInfo;
import io.dekorate.option.annotation.JvmOptions;
import java.lang.Object;
import java.util.List;
import io.dekorate.option.annotation.SecureRandomSource;
import io.dekorate.project.ScmInfo;
import java.lang.Boolean;
import io.dekorate.option.config.JvmConfig;
import java.util.Map;
import io.dekorate.option.annotation.GarbageCollector;

public class JvmConfigAdapter {


    public static JvmConfig adapt(JvmOptions instance) {
        return newBuilder(instance).build();
    }

    public static JvmConfigBuilder newBuilder(JvmOptions instance) {
        return new JvmConfigBuilder(new io.dekorate.option.config.JvmConfig(null,
                    null,
                    instance.xms(),
                    instance.xmx(),
                    instance.server(),
                    instance.useStringDeduplication(),
                    instance.preferIPv4Stack(),
                    instance.heapDumpOnOutOfMemoryError(),
                    instance.useGCOverheadLimit(),
                    instance.gc(),
                    instance.secureRandom()));
    }

    public static JvmConfig adapt(Map map) {
        return new io.dekorate.option.config.JvmConfig(
        null,
        null,
                       (Integer)(map instanceof Map ? ((Map)map).getOrDefault("xms", null) : null),
                       (Integer)(map instanceof Map ? ((Map)map).getOrDefault("xmx", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("server", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("useStringDeduplication", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("preferIPv4Stack", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("heapDumpOnOutOfMemoryError", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("useGCOverheadLimit", null) : null),
                       (GarbageCollector)(map instanceof Map ? ( ((Map)map).getOrDefault("gc", null) != null ? GarbageCollector.valueOf(String.valueOf(((Map)map).getOrDefault("gc", null))) : null ) : null),
                       (SecureRandomSource)(map instanceof Map ? ( ((Map)map).getOrDefault("secureRandom", null) != null ? SecureRandomSource.valueOf(String.valueOf(((Map)map).getOrDefault("secureRandom", null))) : null ) : null));
    }

    public static JvmConfigBuilder newBuilder(Map map) {
        return new JvmConfigBuilder(new io.dekorate.option.config.JvmConfig(
        null,
        null,
                       (Integer)(map instanceof Map ? ((Map)map).getOrDefault("xms", null) : null),
                       (Integer)(map instanceof Map ? ((Map)map).getOrDefault("xmx", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("server", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("useStringDeduplication", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("preferIPv4Stack", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("heapDumpOnOutOfMemoryError", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("useGCOverheadLimit", null) : null),
                       (GarbageCollector)(map instanceof Map ? ( ((Map)map).getOrDefault("gc", null) != null ? GarbageCollector.valueOf(String.valueOf(((Map)map).getOrDefault("gc", null))) : null ) : null),
                       (SecureRandomSource)(map instanceof Map ? ( ((Map)map).getOrDefault("secureRandom", null) != null ? SecureRandomSource.valueOf(String.valueOf(((Map)map).getOrDefault("secureRandom", null))) : null ) : null)));
    }

    public static String[] toStringArray(Object o) {
                if (o instanceof String[]) {
                  return (String[]) o;
                }
                if (o instanceof String) {
                  String s =  (String) o;
                  return s.split(",[ ]*");
                }
                else if (o instanceof List) {
                  List c = (List) o;
                  String[] result = new String[c.size()]; 
                  for (int i=0; i <= c.size(); i++) {
                    result[i] = String.valueOf(c.get(i));
                  }
                  return result;
                }
                return new String[0];
            
    }

}
